clear all;
clc
load environ_cal_9
Z_STATE   = uint16(Z_STATE);
load H_all
load functions

%==========================================================================
% Modified the Eshocks for each group
%==========================================================================
Z_std = (Inv_Ztrans*(Zshocks - Inv_Ztrans*Zshocks).^2)^(1/2);
Ztrans_total = repmat(Ztrans(ZlagRe1st,:),Enum,Enum);
index = [ZlagRe1st ;ZlagRe1st+Znum];
EZtrans_total = EZtrans(index,:);


for case_ind = 1:size(MM,2)
    case_ind
    omega1 = MM(1,case_ind);
    omega2 = MM(2,case_ind);
    omega3 = MM(3,case_ind);
    omega4 = MM(4,case_ind);
    omega5 = MM(5,case_ind);

    H = H_all{1,case_ind}
    Sav_com   = Sav_functions{1,case_ind};
    Sav_z    = Sav_functions{2,case_ind};
    Sav_cap  = Sav_functions{3,case_ind};
    Sav_bond = Sav_functions{4,case_ind};
    Sav_pr_b = Sav_functions{5,case_ind};
    Sav_pr_nb= Sav_functions{6,case_ind};
    Cpr_com  = Cpr_functions{1,case_ind};
    Cpr_z    = Cpr_functions{2,case_ind};
    Cpr_cap  = Cpr_functions{3,case_ind};
    Cpr_bond = Cpr_functions{4,case_ind};
    Cpr_b    = Cpr_functions{5,case_ind};
    Cpr_nb   = Cpr_functions{6,case_ind};

%==========================================================================
% Asset Prices
%==========================================================================
    R_z_final = beta*repmat(Zshocks'.^-gama,ZtotalRe,1).*Ztrans(ZlagRe1st,:).*H.^gama;
    risk_free = sum(R_z_final,2).^(-1);
    
    % P/d ratio for aggregate consumption
    ac_temp = sum(R_z_final.*repmat(Zshocks',ZtotalRe,1),2);
    zshocks_tmp = zeros(ZtotalRe,ZtotalRe);
       for i = 1:ZtotalRe
         zshocks_tmp(i,ZINDRe(i,:)) = R_z_final(i,:).*Zshocks';
       end  
    ac_pd = inv(eye(ZtotalRe)-zshocks_tmp)*ac_temp;
    Return_LCS  = (((ac_pd(ZINDRe) + 1).*repmat(Zshocks',ZtotalRe,1)./repmat(ac_pd,1,Znum)...
            -L*repmat(risk_free,1,Znum))/(1-L))./repmat(Zshocks',ZtotalRe,1);
    Return_RFS  = repmat(risk_free,1,Znum)./repmat(Zshocks',ZtotalRe,1);
    risk_free_total  = repmat(risk_free,Enum,1);
    pos{1}        = (1:ZtotalRe*Enum)'; 
    pos{2}        = EZINDRe; 
    
    % K period return and H
    for k=2:K
    for i=1:ZtotalRe*Enum
        pos{k+1}(i,:) = reshape(EZINDRe(pos{k}(i,:),:)',1,(Enum*Znum)^k);
    end
    end
    
%==========================================================================
% Simulation Panel
%==========================================================================
tic
disp('simulation panel')
  C_STATE =repmat(single(1),N-1,T);
  H_STATE =repmat(single(1),size(T_STATERe));
  cpr     =repmat(single(1),N-1,1);  
  h_update = repmat(single(1),T,1);
  N1 = round((N-1)*omega1);
  N2 = round((N-1)*(omega2+omega1));
  N3 = round((N-1)*(omega3+omega2+omega1));
  N4 = round((N-1)*(omega4+omega3+omega2+omega1));
  C_STATE_N5 = repmat(single(1),N-1-N4,K);
  C_STATE_TMP = repmat(single(1),N-1,2);
  NCOM        = 1000;
  NZ          = 1000;
  C_STATE_COM = repmat(single(1),NCOM,T);
  C_STATE_Z   = repmat(single(1),NZ,T);
   cpr_tmpsim = cell(K,K+1);
  for kk=1:K
      for k=1:K+1
      cpr_tmpsim{kk,k} = ones(N-1-N4,1);
      end
  end
 
  for t=1:T-K
      pick = [(E_STATE(:,t)==1).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==1).*(E_STATE(:,t+1)==2)...
             (E_STATE(:,t)==2).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==2).*(E_STATE(:,t+1)==2)];
         
      Agg_pick =  [Z_STATE(1,t+1) Z_STATE(1,t+1)+Znum];
      
      if omega1~=0      
         cp_tmp       = [Cpr_com{T_STATERe(1,t)}(:,Agg_pick) Cpr_com{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(1:N1)    = sum(interp1(mgrid2,cp_tmp,C_STATE(1:N1,t),'linear','extrap').*pick(1:N1,:),2);
         C_STATE_TMP(:,1)  = sum(interp1(mgrid2,cp_tmp,C_STATE_TMP(:,1),'linear','extrap').*pick,2);
      end
      
      if omega2~=0
         cp_tmp     = [Cpr_z{T_STATERe(1,t)}(:,Agg_pick) Cpr_z{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N1+1:N2)  = sum(interp1(mgrid2,cp_tmp,C_STATE(N1+1:N2,t),'linear','extrap').*pick(N1+1:N2,:),2);
         C_STATE_TMP(:,2)  = sum(interp1(mgrid2,cp_tmp,C_STATE_TMP(:,2),'linear','extrap').*pick,2);
      end
      
      if omega3~=0
         cp_tmp     = [Cpr_cap{T_STATERe(1,t)}(:,Agg_pick) Cpr_cap{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N2+1:N3)   = sum(interp1(mgrid2,cp_tmp,C_STATE(N2+1:N3,t),'linear','extrap').*pick(N2+1:N3,:),2);
      end
      
      if omega4~=0
         cp_tmp     = [Cpr_bond{T_STATERe(1,t)}(:,Agg_pick) Cpr_bond{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N3+1:N4)   = sum(interp1(mgrid2,cp_tmp,C_STATE(N3+1:N4,t),'linear','extrap').*pick(N3+1:N4,:),2);
      end
      
      if omega5~=0
          kk = rem(t-1,K)+1;
          if t>K
          C_STATE_N5(:,kk) = C_STATE_N5(:,kk)/h_update(t-1);
          end
             Agg_pick2{1} = Agg_pick;
             clear pick2
             pick2{1}     = pick;
            for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end
                cp_tmptmp{k} = [Cpr_nb{k,T_STATERe(1,t)}(:,Agg_pick2{k-1}) Cpr_nb{k,T_STATERe(1,t)+ZtotalRe}(:,Agg_pick2{k-1})];
                cpr_tmpsim{kk,k}   = sum(interp1(mgrid2,cp_tmptmp{k},C_STATE_N5(:,kk),'linear','extrap').*pick2{k-1}(N4+1:N-1,:),2);
            end
                
            cp_tmptmp{K+1} = [Cpr_b{T_STATERe(1,t)}(:,Agg_pick2{k}) Cpr_b{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick2{k})];
            cpr_tmpsim{kk,K+1}   = sum(interp1(mgrid2,cp_tmptmp{K+1},C_STATE_N5(:,kk),'linear','extrap').*pick2{k}(N4+1:N-1,:),2);
            C_STATE_N5(:,kk) = cpr_tmpsim{kk,K+1};
            for kkk=1:K
            cpr_tmpN5(:,kkk) = cpr_tmpsim{kkk,Choose(kkk,kk)};
            end            
            cpr(N4+1:N-1) = sum(cpr_tmpN5.*kron(eye(K),ones((N-1-N4)/K,1)),2);
      end
      
      cpr = min(cpr,1.5*Mmax); 
      h_update(t) = mean(C_STATE_TMP(:,1))*omega1 + mean(C_STATE_TMP(:,2))*omega2 + (1-omega1-omega2)*mean(cpr(N2+1:N-1));
      C_STATE(:,t+1) = cpr/h_update(t);
      C_STATE_TMP = C_STATE_TMP/h_update(t);
      C_STATE_COM(:,t+1) = C_STATE_TMP(1:NCOM,1);
      C_STATE_Z(:,t+1)   = C_STATE_TMP(1:NZ,2);
      H_STATE(1,t+1) = h_update(t)*H(T_STATERe(1,t),Z_STATE(1,t+1)); 
  end
toc
%==========================================================================
% This program compuite the wealth return for traders
%==========================================================================
All_com = zeros(1,8); All_z = zeros(1,8); All_cap = zeros(1,8); 
All_bond = zeros(1,8); All_prb = zeros(1,8);
%==========================================================================
% cases com diversified capital bond
%==========================================================================
      if omega1~=0
         std_cg1 = mean(std(repmat(Zshocks(Z_STATE(2:T))',NCOM,1).*C_STATE_COM(:,2:T)./C_STATE_COM(:,1:T-1),0,2))/Z_std;
         CS1 = mean(C_STATE_COM)';
         std_CG1 = std((CS1(2:end)./CS1(1:end-1)).*Zshocks(Z_STATE(2:T)))/Z_std;         
                 
         NetSav_com = max(-Sav_com - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,1)',dimgrid2,1),0.01);
         Sav_com_tmp = max(-Sav_com,0);
         for i=1:ZtotalRe*Enum;
             EZtrans_tmp = EZtrans_total(i,:);
             for j=1:Enum*Znum
                 Sav_pr(:,j) = interp1(mgrid2,Sav_com_tmp(:,EZINDRe(i,j)),Cpr_com{i}(:,j),'linear','extrap');
             end
             ExRe = (Sav_pr./repmat(NetSav_com(:,i),1,Enum*Znum)).*repmat(Zshocks',dimgrid2,2) - risk_free_total(i,1);
             WRe_com{i}        = ExRe;
             WExRe_com(:,i)    = ExRe*EZtrans_tmp';
             WStdExRe_com(:,i) = ((ExRe - repmat(ExRe*EZtrans_tmp',1,Enum*Znum)).^2*EZtrans_tmp').^(1/2);
         end
         MeanW     = repmat(single(0),1,T-1);
         StdW      = repmat(single(0),1,T-1);
         warning off
         for t=1:T-1
             pick   = (E_STATE(1:NCOM,t)==1);
             pickpr = [(E_STATE(1:NCOM,t+1)==1) (E_STATE(1:NCOM,t+1)==2)];
             
             pick1 = find(E_STATE(1:NCOM,t)==1);
             pick2 = find(E_STATE(1:NCOM,t)==2);
             nn1  = find(Sav_com(:,T_STATERe(t))<-0.1);
             nn2  = find(Sav_com(:,T_STATERe(t)+ZtotalRe)<-0.1);
             nn1  = nn1(1)-1;
             nn2  = nn2(1)-1;
                         
             pick11 = find(C_STATE_COM(pick1,t)>mgrid2(nn1));
             pick22 = find(C_STATE_COM(pick2,t)>mgrid2(nn2));

             C_STATE_TMPCOM1 = C_STATE_COM(pick1(pick11),t);
             C_STATE_TMPCOM2 = C_STATE_COM(pick2(pick22),t);
             
             agg_pick          = (Z_STATE(t+1)==1)*[1 3] + (Z_STATE(t+1)==2)*[2 4]; 
             WRe_sim(1,t)      = mean([sum(interp1(mgrid2,WRe_com{T_STATERe(t)}(:,agg_pick),C_STATE_TMPCOM1,'linear','extrap').*pickpr(pick1(pick11),:),2) ;...
                                  sum(interp1(mgrid2,WRe_com{T_STATERe(t)+ZtotalRe}(:,agg_pick),C_STATE_TMPCOM2,'linear','extrap').*pickpr(pick2(pick22),:),2) ]);                             
                             
             Wtmp = max(interp1(mgrid2,NetSav_com(:,T_STATERe(t)),C_STATE_COM(:,t),'linear','extrap').*pick+...
                                 interp1(mgrid2,NetSav_com(:,T_STATERe(t)+ZtotalRe),C_STATE_COM(:,t),'linear','extrap').*(1-pick),0);
                             
             MeanW(1,t)        = mean(Wtmp);
             StdW(1,t)         = std(Wtmp);    
         end
         
         Avg_ExReturn_W_com = mean(WRe_sim);
         Std_ExReturn_W_com = std(WRe_sim);
         Sharp_W_com = Avg_ExReturn_W_com/Std_ExReturn_W_com;
         
         Mean_Wealth_com = mean(MeanW);
         Std_Wealth_com  = mean(StdW);
         
         All_com = [std_cg1 std_CG1 mean(CS1) Avg_ExReturn_W_com Std_ExReturn_W_com Sharp_W_com Mean_Wealth_com Std_Wealth_com];
         disp('All_com')
         latex(double(All_com))
      end

      if omega2~=0
         std_cg2 = mean(std(repmat(Zshocks(Z_STATE(2:T))',NZ,1).*C_STATE_Z(:,2:T)./C_STATE_Z(:,1:T-1),0,2))/Z_std; 
         CS2 = mean(C_STATE_Z)';
         std_CG2 = std((CS2(2:end)./CS2(1:end-1)).*Zshocks(Z_STATE(2:T)))/Z_std;
         NetSav_z = max(-Sav_z - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,2)',dimgrid2,1),0.01);
         Sav_z_tmp = max(-Sav_z,0);
         for i=1:ZtotalRe*Enum;
             EZtrans_tmp = EZtrans_total(i,:);
             for j=1:Enum*Znum
                 Sav_pr(:,j) = interp1(mgrid2,Sav_z_tmp(:,EZINDRe(i,j)),Cpr_z{i}(:,j),'linear','extrap');
             end
             ExRe = (Sav_pr./repmat(NetSav_z(:,i),1,Enum*Znum)).*repmat(Zshocks',dimgrid2,Enum) - risk_free_total(i,1);
             WRe_z{i}        = ExRe(:,[1 2]);
             WExRe_z(:,i)    = ExRe*EZtrans_tmp';
             WStdExRe_z(:,i) = ((ExRe - repmat(ExRe*EZtrans_tmp',1,Enum*Znum)).^2*EZtrans_tmp').^(1/2);
         end
         
         WExRe_sim = repmat(single(0),1,T-1);
         WRe_sim   = repmat(single(0),1,T-1);
         MeanW     = repmat(single(0),1,T-1);
         StdW      = repmat(single(0),1,T-1);  

         for t=1:T-1
             pick = (E_STATE(1:NZ,t)==1);
             pick1 = find(E_STATE(1:NZ,t)==1);
             pick2 = find(E_STATE(1:NZ,t)==2);
             
             nn1  = find(Sav_z(:,T_STATERe(t))<-0.5);
             nn2  = find(Sav_z(:,T_STATERe(t)+ZtotalRe)<-0.5);
             nn1  = nn1(1);
             nn2  = nn2(1);
             
             pick11 = find(C_STATE_Z(pick1,t)>mgrid2(nn1));
             pick22 = find(C_STATE_Z(pick2,t)>mgrid2(nn2));
             
             C_STATE_TMPZ1 = C_STATE_Z(pick1(pick11),t);
             C_STATE_TMPZ2 = C_STATE_Z(pick2(pick22),t);
             
             WRe_sim(1,t)      = mean([interp1(mgrid2,WRe_z{T_STATERe(t)}(:,Z_STATE(t+1)),C_STATE_TMPZ1,'linear','extrap');...
                                  interp1(mgrid2,WRe_z{T_STATERe(t)+ZtotalRe}(:,Z_STATE(t+1)),C_STATE_TMPZ2,'linear','extrap')]);
                        
             WExRe_sim(1,t)    = mean([interp1(mgrid2,WExRe_z(:,T_STATERe(t)),C_STATE_TMPZ1,'linear','extrap');...
                                  interp1(mgrid2,WExRe_z(:,T_STATERe(t)+ZtotalRe),C_STATE_TMPZ2,'linear','extrap')]);
                                                                 
             
             Wtmp = max(interp1(mgrid2,NetSav_z(:,T_STATERe(t)),C_STATE_Z(:,t),'linear','extrap').*pick+...
                                 interp1(mgrid2,NetSav_z(:,T_STATERe(t)+ZtotalRe),C_STATE_Z(:,t),'linear','extrap').*(1-pick),0);
                                                          
             MeanW(1,t)        = mean(Wtmp);
             StdW(1,t)         = std(Wtmp);    
         end
         
         Avg_ExReturn_W_z = mean(WRe_sim);
         
         Std_ExReturn_W_z = std(WRe_sim);
         Sharp_W_z = Avg_ExReturn_W_z/Std_ExReturn_W_z;
         
         Mean_Wealth_z = mean(MeanW);
         Std_Wealth_z  = mean(StdW);
         
         All_z = [std_cg2 std_CG2 mean(CS2) Avg_ExReturn_W_z Std_ExReturn_W_z Sharp_W_z Mean_Wealth_z Std_Wealth_z];
         disp('All_z')
         latex(double(All_z))  
      end
      
      if omega3~=0              
         std_cg3 = mean(std(repmat(Zshocks(Z_STATE(2:T))',N3-N2,1).*C_STATE(N2+1:N3,2:T)./C_STATE(N2+1:N3,1:T-1),0,2))/Z_std;
         CS3 = mean(C_STATE(N2+1:N3,:))';
         std_CG3 = std((CS3(2:end)./CS3(1:end-1)).*Zshocks(Z_STATE(2:end)))/Z_std;
         
         ExRe_tmp = (port_share*Return_LCS + (1-port_share)*Return_RFS).*repmat(Zshocks',ZtotalRe,1) - repmat(risk_free,1,Znum);
         ExRe     =  sum(ExRe_tmp.*Ztrans(ZlagRe1st(:,1),:),2);
         StdExRe  =  sum((ExRe_tmp - repmat(ExRe,1,Znum)).^2.*Ztrans(ZlagRe1st(:,1),:),2).^(1/2);
         NetSav_cap = max(-Sav_cap - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,3)',dimgrid2,1),0.001);
         MeanW     = repmat(single(0),1,T-1);
         StdW      = repmat(single(0),1,T-1);           
         for t=1:T-1
             pick = (E_STATE(N2+1:N3,t)==1);
             Wtmp = max(interp1(mgrid2,NetSav_cap(:,T_STATERe(t)),C_STATE(N2+1:N3,t),'linear','extrap').*pick+...
                                 interp1(mgrid2,NetSav_cap(:,T_STATERe(t)+ZtotalRe),C_STATE(N2+1:N3,t),'linear','extrap').*(1-pick),0);
             Re_cap_sim(1,t) = ExRe_tmp(T_STATERe(t),Z_STATE(t+1));
             MeanW(1,t)        = mean(Wtmp);
             StdW(1,t)         = std(Wtmp);    
         end
         
         Avg_ExReturn_W_cap = mean(Re_cap_sim);
         Std_ExReturn_W_cap = std(Re_cap_sim);
         Sharp_W_cap = Avg_ExReturn_W_cap/Std_ExReturn_W_cap;
         
         Mean_Wealth_cap = mean(MeanW);
         Std_Wealth_cap  = mean(StdW);
         
         All_cap = [std_cg3 std_CG3 mean(CS3) Avg_ExReturn_W_cap Std_ExReturn_W_cap Sharp_W_cap Mean_Wealth_cap Std_Wealth_cap];
         
         disp('All_cap')
         latex(double(All_cap))       
      end
      
      if omega4~=0
         std_cg4 = mean(std(repmat(Zshocks(Z_STATE(2:T))',N4-N3,1).*C_STATE(N3+1:N4,2:T)./C_STATE(N3+1:N4,1:T-1),0,2))/Z_std;
         CS4 = mean(C_STATE(N3+1:N4,:))';
         std_CG4 = std((CS4(2:end)./CS4(1:end-1)).*Zshocks(Z_STATE(2:end)))/Z_std;
         NetSav_bond = max(-Sav_bond - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,4)',dimgrid2,1),0.001);
         MeanW     = repmat(single(0),1,T-1);
         StdW      = repmat(single(0),1,T-1);  
         for t=1:T-1
             pick = (E_STATE(N3+1:N4,t)==1);
             Wtmp = max(interp1(mgrid2,NetSav_bond(:,T_STATERe(t)),C_STATE(N3+1:N4,t),'linear','extrap').*pick+...
                                 interp1(mgrid2,NetSav_bond(:,T_STATERe(t)+ZtotalRe),C_STATE(N3+1:N4,t),'linear','extrap').*(1-pick),0);
             MeanW(1,t)        = mean(Wtmp);
             StdW(1,t)         = std(Wtmp);    
         end
         
                  
         Avg_ExReturn_W_bond = 0;
         Std_ExReturn_W_bond = 0;
         Sharp_W_bond = NaN;
         Mean_Wealth_bond = mean(MeanW);
         Std_Wealth_bond  = mean(StdW);

         All_bond = [std_cg4 std_CG4 mean(CS4) Avg_ExReturn_W_bond Std_ExReturn_W_bond Sharp_W_bond Mean_Wealth_bond Std_Wealth_bond];
         disp('All_bond')
         latex(double(All_bond))
      end
      
      
      if omega5~=0
         clear pick2 
         pick2{1} = [(E_STATE(:,t)==1).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==1).*(E_STATE(:,t+1)==2)...
                 (E_STATE(:,t)==2).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==2).*(E_STATE(:,t+1)==2)]; 

         std_cg5 = mean(std(repmat(Zshocks(Z_STATE(2:T))',N-1-N4,1).*C_STATE(N4+1:N-1,2:T)./C_STATE(N4+1:N-1,1:T-1),0,2))/Z_std;
         CS5 = mean(C_STATE(N4+1:N-1,:))';
         std_CG5 = std((CS5(2:end)./CS5(1:end-1)).*Zshocks(Z_STATE(2:end)))/Z_std;
         ExRe = repmat(single(0),T-k,K);
         Re   = repmat(single(0),T-k,K);
         StdExRe = repmat(single(0),T-k,K);
         
         
         NetSav_pr_b  =  max(-Sav_pr_b - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,5)',dimgrid2,1),0.001);
         NetSav_pr_nb = cell(K,ZtotalRe*Enum);
         for k=2:K;
         for i=1:ZtotalRe*Enum
             NetSav_pr_nb{k,i} = -Sav_pr_nb{k,i} - repmat(mgrid2,1,(Enum*Znum)^(k-1)) + repmat(Income_total(pos{k}(i,:),5)',dimgrid2,1); 
         end
         end 
         
         for k=1:K
         ps = port_share;
         for t=1:T-K
             index = rem(t-1+k-1,K)+1;
             ps = (index==1)*port_share + (index~=1)*ps;
             Re_tmp_LC = Return_LCS(T_STATERe(t),:).*Zshocks';
             Re_tmp_RF = Return_RFS(T_STATERe(t),:).*Zshocks';
             Re_tmp   = ps*Re_tmp_LC + (1-ps)*Re_tmp_RF;
             ExRe_tmp = Re_tmp - risk_free(T_STATERe(t));
             Re(t,k)  = ExRe_tmp(Z_STATE(t+1)); 
             ExRe(t,k) = ExRe_tmp*Ztrans(Z_STATE(t),:)';
             StdExRe(t,k) = ((ExRe_tmp - ExRe(t,1)).^2*Ztrans(Z_STATE(t),:)').^(1/2);
             ps = ps*Re_tmp_LC(Z_STATE(t+1))/Re_tmp(Z_STATE(t+1));
         end
         end
        
      Avg_ExReturn_W_prb = mean(mean(Re,2));
      Std_ExReturn_W_prb = std(mean(Re,2));
      Sharp_W_prb = Avg_ExReturn_W_prb/Std_ExReturn_W_prb;
      
      tt = T-K;
      tt_i = 4000; % Number of period to simulate
      % Compute the wealth dist for prb  
      % first K-1 periods before jj
      AWH_prb_tmp = repmat(single(0),N-1-N4,tt_i+1);
      port_sim_prb = repmat(single(0),N-1-N4,tt_i+1);
      clear Port_prb_tmp1
      for kkkk=1:K-1
         jj=tt-tt_i-K+kkkk;
         kk = rem(jj-1,K)+1;
         AWH_prb_tmp2{kk,1} = max(([interp1(mgrid2,NetSav_pr_b(:,T_STATERe(jj)),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==1)+...
                                interp1(mgrid2,NetSav_pr_b(:,T_STATERe(jj)+ZtotalRe),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==2)]),0);                   
                            
                            
         Port_prb_tmp2{kk,1} = port_share*ones(N-1-N4,1);
         for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end       
                AWH_prb_tmp3  = AWH_prb_tmp2{kk,k-1}-C_STATE(N4+1:N-1,jj+k-2)+...
                                Eshocks_total(repmat(uint8(Z_STATE(jj+k-2)),N-1-N4,1)+2*(E_STATE(N4+1:N-1,jj+k-2)-1),1);           
                AWH_prb_tmp2{kk,k} = sum(max(([interp1(mgrid2,NetSav_pr_nb{k,T_STATERe(jj)}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))...
                                       interp1(mgrid2,NetSav_pr_nb{k,T_STATERe(jj)+ZtotalRe}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))]),0.01).*pick2{k-1}(N4+1:N-1,:),2)...
                                       + AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1));
                Port_prb_tmp2{kk,k} = AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1))./AWH_prb_tmp2{kk,k}; 
         end                   
      end
      % jj starts here          
         for jj=tt-tt_i:tt
         kk = rem(jj-1,K)+1;
         Agg_pick2{1} = [Z_STATE(1,jj+1) Z_STATE(1,jj+1)+Znum];
         pick2{1}     = [(E_STATE(:,jj)==1).*(E_STATE(:,jj+1)==1) (E_STATE(:,jj)==1).*(E_STATE(:,jj+1)==2)...
                         (E_STATE(:,jj)==2).*(E_STATE(:,jj+1)==1) (E_STATE(:,jj)==2).*(E_STATE(:,jj+1)==2)];
                     
         AWH_prb_tmp2{kk,1} = max(([interp1(mgrid2,NetSav_pr_b(:,T_STATERe(jj)),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==1)+...
                                interp1(mgrid2,NetSav_pr_b(:,T_STATERe(jj)+ZtotalRe),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==2)]),0.01);
                            
         Port_prb_tmp2{kk,1} = port_share*ones(N-1-N4,1);
           for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end     
                AWH_prb_tmp3  = AWH_prb_tmp2{kk,k-1}-C_STATE(N4+1:N-1,jj+k-2)+...
                                Eshocks_total(repmat(uint8(Z_STATE(jj+k-2)),N-1-N4,1)+2*(E_STATE(N4+1:N-1,jj+k-2)-1),1);           
                AWH_prb_tmp2{kk,k} = sum(max(([interp1(mgrid2,NetSav_pr_nb{k,T_STATERe(jj)}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))...
                                       interp1(mgrid2,NetSav_pr_nb{k,T_STATERe(jj)+ZtotalRe}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))]),0.01).*pick2{k-1}(N4+1:N-1,:),2)...
                                       + AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1));  
                Port_prb_tmp2{kk,k} = AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1))./AWH_prb_tmp2{kk,k};                             
           end

           for kkk=1:K
            AWH_prb_tmp1(:,kkk) = AWH_prb_tmp2{kkk,Choose(kkk,kk)-1};
            Port_prb_tmp1(:,kkk) = Port_prb_tmp2{kkk,Choose(kkk,kk)-1};
           end
            AWH_prb_tmp(:,jj-tt+tt_i+1) = sum(AWH_prb_tmp1.*kron(eye(K),ones((N-1-N4)/K,1)),2);
            port_sim_prb(:,jj-tt+tt_i+1) = sum(Port_prb_tmp1.*kron(eye(K),ones((N-1-N4)/K,1)),2);
         end
        
         Mean_Wealth_prb = mean(mean(AWH_prb_tmp));
         Std_Wealth_prb  = mean(std(AWH_prb_tmp));                
         All_prb = [std_cg5 std_CG5 mean(CS5) Avg_ExReturn_W_prb Std_ExReturn_W_prb Sharp_W_prb Mean_Wealth_prb Std_Wealth_prb]; 
         disp('All_prb')
         latex(double(All_prb))
      end
      omega_all = [omega1 omega2 omega3 omega4 omega5];
      All_tmp = ([All_com; All_z; All_cap; All_bond; All_prb]);
      Avg_W        = omega_all*All_tmp(:,7);
      Std_W        = (omega_all*(All_tmp(:,8).^2+All_tmp(:,7).^2-Avg_W^2))^(1/2);
      All_tmp(:,[7 8]) = All_tmp(:,[7 8])./Avg_W;
      All2(:,case_ind) = [Avg_W Std_W]';
      All{1,case_ind} = reshape(All_tmp,1,prod(size(All_tmp)))';
      save All All All2
end


for i=1:length(All)
    All_table(:,i) = All{i};
end

%==========================================================================
% Making Tables VI
%==========================================================================
% Table IV, Panel I
%==========================================================================
% Excess Return
%==========================================================================
disp('Table IV, Panel I, Excess Return')
latex(double(sum(All_table([16:17],:))*100),'%.3f')
latex(double(sum(All_table([18 20],:))*100),'%.3f')
%==========================================================================
% Sharpe Ratio
%==========================================================================
latex(double(sum(All_table([26:27],:))),'%.3f')
latex(double(sum(All_table([28 30],:))),'%.3f')


%==========================================================================
% Table IV, Panel I
%==========================================================================
% Household Consumption
%==========================================================================
disp('Table IV, Panel II, Consumption')
latex(double(sum(All_table([1 2],:))),'%.3f')
latex(double(sum(All_table([3 5],:))),'%.3f')
latex(double((All_table(4,:))),'%.3f')

latex(double(sum(All_table([6:7],:))),'%.3f')
latex(double(sum(All_table([8 10],:))),'%.3f')
latex(double((All_table(9,:))),'%.3f')

