%==========================================================================
% Asset Pricing Program for Table 3
%==========================================================================
clear all;
clc;

load environ_cal_9
Z_STATE   = uint16(Z_STATE);
load H_all
for ii=1:size(MM,2)
    H = H_all{1,ii};
    H
%==========================================================================
% Pricing Kernal
%==========================================================================
  m = beta*Zshocks(Z_STATE(2:T)).^(-gama).*...
      H(T_STATERe(1:T-1)+ZtotalRe*(Z_STATE(2:T)-1))'.^gama;
  prob{1} = Ztrans(ZlagRe1st,:);

%==========================================================================
% Risk free interest rate
%==========================================================================
    R_z_final = beta*repmat(Zshocks'.^-gama,ZtotalRe,1).*Ztrans(ZlagRe1st,:).*H.^gama;
    risk_free = sum(R_z_final,2).^(-1);
 
%==========================================================================
% P/d ratio for leverage claim (phi is leverage ratio) 
%==========================================================================
Inv_Ztrans = Ztrans^1000;
Inv_Ztrans = Inv_Ztrans(1,:);

phi_all = [3 4];
for j = 1:length(phi_all)
    phi = phi_all(j);
    Divl(:,j) = (Zshocks - repmat(Inv_Ztrans*Zshocks,Znum,1))*phi + repmat(Inv_Ztrans*Zshocks,Znum,1); 
    gaplcpd=1;
    lc_pd_tmp = ones(ZtotalRe,1);
while gaplcpd>10^-15;
    for i=1:ZtotalRe
     lc_pd_new(i,1) = sum((1+lc_pd_tmp(ZINDRe(i,:))').*Divl(:,j)'.*R_z_final(i,:),2);
    end
    gaplcpd = max(abs(lc_pd_tmp - lc_pd_new));
    lc_pd_tmp = lc_pd_new;
end
R_lc{j}    = (repmat(Divl(:,j)',ZtotalRe,1).*(1+lc_pd_tmp(ZINDRe)))./repmat(lc_pd_tmp,1,Znum);
ExR_lc{j}  = R_lc{j} -  repmat(risk_free,1,Znum);
CEExR_lc{j} = sum(ExR_lc{j}.*prob{1},2);
lc_pd(:,j) = lc_pd_tmp;
end

%==========================================================================
% Data simulation aqnd Regression
%==========================================================================

for j=1:2
R_lc_tmp = reshape(R_lc{j},ZtotalRe*Znum,1);
R_lc_sim = R_lc_tmp(T_STATERe(1:T-1)+(Z_STATE(2:T)-1)*ZtotalRe);
Avg_R_lc(:,j) = mean(R_lc_sim);
std_R_lc(:,j) = std(R_lc_sim);
Avg_ExR_lc(:,j) = mean(R_lc_sim - risk_free(T_STATERe(1:T-1)))*100;
std_ExR_lc(:,j) = std(R_lc_sim - risk_free(T_STATERe(1:T-1)))*100;
Sharp_ratio_lc = Avg_ExR_lc./std_ExR_lc;
lc_pd_tmp = lc_pd(:,j);
lc_pd_sim = lc_pd_tmp(T_STATERe(1:T));
Avg_lc_pd(:,j)    = mean(-log(lc_pd_sim));
std_lc_pd(:,j)    = std(-log(lc_pd_sim));
autocorr_lc_pd(:,j)  = autocorr(-log(lc_pd_sim));
end
  
%==========================================================================
% Making tables
%==========================================================================
Allreturn_tmp = [Avg_ExR_lc;std_ExR_lc;Sharp_ratio_lc;std_lc_pd*100;autocorr_lc_pd(2,:)];

Allreturn(ii,:) =  reshape(Allreturn_tmp,numel(Allreturn_tmp),1);
                                       
end

Allreturn = Allreturn';
latex(double(Allreturn),'%.3f')


