clear
close all
%///////////////////////////
% Flows
%///////////////////////////
% Data are quarterly
%%%%%%%%%%%%%%%%%%%%%%%%%%%
data_temp=xlsread('AER_data_rebalancing_CRSP.xlsx','Summary');
payouts_NSA=data_temp(1:end,1:5);

%column 2 : payouts/income
%column 3 : dividend income
%column 4 : dividend/yield
%column 5 : NBER dummies


T=size(payouts_NSA,1);
for i=1:T
year=1947+floor((i-1)/4);
month=rem(3*i,12);
if month==0
    month=12;
end    
dates(i,1) = datenum(year,month,30);
end


X=[ payouts_NSA(1:end,2) payouts_NSA(1:end,3) log(payouts_NSA(1:end,4))];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Baxter-King Bandpass Filter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Quarterly data: pl=6, pu=32 returns component with periods between 1.5 and 8 yrs.
payouts_filter= bpass(X,6,32,0,0,3,8);
%payouts_filter= bpass(X,6,32,0,0);
payouts_NSA(1:end,2)=payouts_filter(:,1);
payouts_NSA(1:end,3)=payouts_filter(:,2);
payouts_NSA(1:end,4)=payouts_filter(:,3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





figure(3)
stepfunctionNBER=payouts_NSA(1:end,end);
y_min = -.15; y_max = .15; 
eps = 0.00007;
lightgray  = [238/255 233/255 233/255];
darkgray   = [180/255 211/255 211/255];

bar(dates(1:end,1),stepfunctionNBER*(y_max-eps),'FaceColor',lightgray,'EdgeColor',lightgray,'BarWidth',2);hold on;
bar(dates(1:end,1),stepfunctionNBER*(y_min+eps),'FaceColor',lightgray,'EdgeColor',lightgray,'BarWidth',2);hold on;
plot(dates(1:end,1),payouts_NSA(1:end,3),'b--','LineWidth',3)
dateaxis
hold on
plot(dates(1:end,1),payouts_NSA(1:end,2),'black-','LineWidth',3)
hold on
%plot(dates(1:end,1),payouts_NSA(1:end,2),'black','LineWidth',3)
%dateaxis
title('Payouts/National Income')

axis([  dates(1,1) 734533  -0.15 0.15]) 
grid

hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
print -depsc -tiff -r300  figure2



figure(4)
stepfunctionNBER=payouts_NSA(1:end,end);
y_min = -.30; y_max = .30; 
eps = 0.00007;
lightgray  = [238/255 233/255 233/255];
darkgray   = [180/255 211/255 211/255];
bar(dates(1:end,1),stepfunctionNBER*(y_max-eps),'FaceColor',lightgray,'EdgeColor',lightgray,'BarWidth',2);hold on;
bar(dates(1:end,1),stepfunctionNBER*(y_min+eps),'FaceColor',lightgray,'EdgeColor',lightgray,'BarWidth',2);hold on;
hold on
plot(dates(1:end,1),payouts_NSA(1:end,4),'black-','LineWidth',3)
hold on
dateaxis
axis([  dates(1,1) 734533  -0.30 0.30]) 
title('Log Dividend Yield')
grid
hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
print -depsc -tiff -r300  figure1
